package com.lsf.cmd;

import javax.servlet.ServletOutputStream;

import org.jfree.chart.ChartUtilities;
import org.jfree.chart.JFreeChart;
import org.jfree.chart.labels.StandardCategoryItemLabelGenerator;
import org.jfree.chart.renderer.category.AbstractCategoryItemRenderer;
import org.jfree.data.general.Dataset;

public abstract class AbstractChartCmd extends AbstractCmd {
	protected int width = 800;
	protected int height = 300;

	protected void request() throws Exception {
		createImage();
	}

	protected void displayItemValue(AbstractCategoryItemRenderer renderer) {
        renderer.setBaseItemLabelGenerator(new StandardCategoryItemLabelGenerator());
        renderer.setItemLabelsVisible(true);
	}

	protected void createImage() throws Exception {
		res.setHeader("Cache-Control", "no-store");
		res.setHeader("Pragma", "no-cache");
		res.setDateHeader("Expires", 0);
		res.setContentType("image/jpeg");
		ServletOutputStream responseOutputStream = res.getOutputStream();
		// responseOutputStream.write(captchaChallengeAsJpeg);
		JFreeChart chart = createChart(createDataset());
		ChartUtilities.writeChartAsPNG(responseOutputStream, chart, width,
				height);
		responseOutputStream.flush();
		responseOutputStream.close();
	}

	abstract protected Dataset createDataset() throws Exception;

	abstract protected JFreeChart createChart(Dataset dataset) throws Exception;
}
