package com.lsf.cmd;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.SQLException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.lsf.util.CollectionUtility;
import com.lsf.util.CommonMap;
import com.lsf.util.PageMap;
import com.lsf.db.DBConnection;


public abstract class AbstractCmd {
	protected HttpServletRequest req;

	protected HttpServletResponse res;

	protected HttpSession session;

	protected Connection conn;

	protected boolean isNoSave = true;

	abstract protected void request() throws Exception;

	private int getOutputStreamInvokeCount = 0;

	protected boolean getAuth() {
		return !(session.getAttribute("user") == null);
	}

	public void service(HttpServletRequest arg0, HttpServletResponse arg1) throws ServletException, IOException {
		this.req = (HttpServletRequest)arg0;
		this.res = (HttpServletResponse)arg1;

		req.setCharacterEncoding(CommonMap.getValue("/prj/conf/encoding"));

		session = req.getSession();

		if (!getAuth()) {
			PrintWriter out;
			try {
				out = getOutputStream();
				out.println("<script>");
				out.println("alert('α Ͻʽÿ');");
				out.println("top.location.href=\"\"");
				out.println("</script>");
			} catch (IOException e) {
				println("EXCEPTION ["+this.getClass().getName()+"]", e);
				e.printStackTrace();
				throw e;
			}
			return;
		}
		printStart();
		long startTime = java.util.Calendar.getInstance().getTimeInMillis();

		try {
			makeConnection();

			isNoSave = Boolean.parseBoolean(CommonMap.getValue("/prj/conf/noSave"));

			res.setHeader("Pragma", "No-cache");
            res.setHeader("Cache-Control", "No-cache");
            res.setHeader("Expires", "1");

			request();

			// system.properties    Ǿ   
			if (isNoSave)
				conn.rollback();
			else
				conn.commit();

		} catch (Exception e) {
			e.printStackTrace();
			try {
				if (conn != null)
					conn.rollback();
			} catch (SQLException e1) {
				println("EXCEPTION ["+this.getClass().getName()+"]", e);
			}
			println("EXCEPTION ["+this.getClass().getName()+"]", e);
			throw new ServletException(e);
		} finally {
			closeConnection();
			printEnd(startTime);
		}
	}

	private void printStart() {
		if (Boolean.valueOf(CommonMap.getValue("/prj/conf/isDebug")).booleanValue())
			println(java.util.Calendar.getInstance().getTime()+" -- Application START : ["+this.getClass().getName()+"] " + req.getRequestURL() + "?" + req.getQueryString());
	}

	private void printEnd(long startTime) {
		long during = java.util.Calendar.getInstance().getTimeInMillis() - startTime;
		if (Boolean.valueOf(CommonMap.getValue("/prj/conf/isDebug")).booleanValue())
			println(java.util.Calendar.getInstance().getTime()+" -- Application END   : ["+this.getClass().getName()+"] ("+during+"ms)");
	}

	protected void println(String str) {
		boolean b = Boolean.parseBoolean(CommonMap
				.getValue("/prj/system/debugPrint/cmd"));
		if (!b)
			return;

		java.util.Calendar now = java.util.Calendar.getInstance();
		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
				"yyyyMMdd");
		String filename = CommonMap.getValue("/prj/system/debugPrint/cmdPath")
				+ "/" + sdf.format(now.getTime());

		File dir = new File(CommonMap.getValue("/prj/system/debugPrint/cmdPath"));
		if (!dir.exists())
			dir.mkdirs();


		java.io.File file = new java.io.File(filename + ".log");
		if (!file.exists())
			try {
				file.createNewFile();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		try {
			FileWriter writer = new FileWriter(file, true);
			writer.write(str+"\n");
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}


	protected void println(String str, Exception e) {
		boolean b = Boolean.parseBoolean(CommonMap
				.getValue("/prj/system/debugPrint/cmd"));
		if (!b)
			return;

		java.util.Calendar now = java.util.Calendar.getInstance();
		java.text.SimpleDateFormat sdf = new java.text.SimpleDateFormat(
				"yyyyMMdd");
		String filename = CommonMap.getValue("/prj/system/debugPrint/cmdPath")
				+ "/" + sdf.format(now.getTime());

		File dir = new File(CommonMap.getValue("/prj/system/debugPrint/cmdPath"));
		if (!dir.exists())
			dir.mkdirs();

		java.io.File file = new java.io.File(filename + ".log");
		if (!file.exists())
			try {
				file.createNewFile();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		try {
			FileWriter writer = new FileWriter(file, true);
			writer.write(java.util.Calendar.getInstance().getTime().toString()+"\t");
			writer.write(str+"\n");
			writer.write(CollectionUtility.getData(req)+"\n");
			writer.write(e.getClass().getName()+": "+e.getMessage()+"\n");
			StackTraceElement ste[] = e.getStackTrace();
			for (int i = 0; i < ste.length; i++)
				writer.write("\t\t"+ste[i].toString()+"\n");
			writer.close();
		} catch (IOException e1) {
			e1.printStackTrace();
		}
	}

	/**
	 * ͺ̽ ؼ Ѵ.
	 * @throws SQLException
	 *
	 */
	protected void makeConnection() throws SQLException {
		try {
			conn = DBConnection.getConnection();
			conn.setAutoCommit(false);
		} catch (SQLException e) {
			e.printStackTrace();
			throw e;
		}
	}

	/**
	 * ͺ̽ ؼ Ѵ.
	 *
	 */
	protected void closeConnection() {
		DBConnection.close(conn);
	}

	protected void forward(String url) {
		RequestDispatcher dispatcher = req.getRequestDispatcher(url);
		try {
			dispatcher.forward(req, res);
		} catch (ServletException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	protected void forwardById(String name) {
		forward(PageMap.getPage(req.getRequestURI(), name));
	}


	protected void printMessage(String msg) {
		PrintWriter out;
		try {
			out = getOutputStream();
			out.println(msg);
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	protected void alert(String msg) {
		PrintWriter out;
		try {
			out = getOutputStream();
			out.println("<script>");
			out.println("alert(\"" + msg + "\");");
			out.println("</script>");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	protected void alertAndClose(String msg) {
		PrintWriter out;
		try {
			out = getOutputStream();
			out.println("<script>");
			out.println("alert(\"" + msg + "\");");
			out.println("self.close()");
			out.println("</script>");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	protected void alertAndHistoryBack(String msg) {
		PrintWriter out;
		try {
			out = getOutputStream();
			out.println("<script>");
			out.println("alert(\"" + msg + "\");");
			out.println("history.go(-1);");
			out.println("</script>");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	protected void alertAndGoUrl(String msg, String url) {
		PrintWriter out;
		try {
			out = getOutputStream();
			out.println("<script>");
			out.println("alert(\"" + msg + "\");");
			out.println("document.location.href=\"" + url + "\"");
			out.println("</script>");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	protected void alertAndGoPageId(String msg, String id) {
		PrintWriter out;
		try {
			out = getOutputStream();
			out.println("<script>");
			out.println("alert(\"" + msg + "\");");
			out.println("document.location.href=\"" + PageMap.getPage(req.getRequestURI(), id) + "\"");
			out.println("</script>");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	protected PrintWriter getOutputStream() throws IOException {
		if (getOutputStreamInvokeCount > 0)
			return res.getWriter();

		getOutputStreamInvokeCount++;

		res.setContentType("text/html; charset="+CommonMap.getValue("/prj/conf/encoding"));
		PrintWriter out = res.getWriter();
		res.setHeader("Pragma", "No-cache");
		res.setHeader("Cache-Control", "No-cache");
		res.setHeader("Expires", "1");

		return out;
	}

	/**
	 * document.location.href  .
	 * @param url
	 */
	protected void sendRedirect(String url) {
		PrintWriter out;
		try {
			out = getOutputStream();
			out.println("<script>");
			out.println("document.location.href=\"" + url + "\"");
			out.println("</script>");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
