package com.lsf.db;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import javax.naming.NamingException;

import com.lsf.util.CommonMap;

/*
 * Created on 2003-10-08
 *
 * 
 * 
 */

/**
 * @author õȣ
 *
 * 
 */
public class DBConnection {
	static int count = 0;

	public static Connection getConnection() throws SQLException {
		Connection conn = null;
		try {
			if (CommonMap.getValue("/prj/conf/useDB").equals("JDBC"))
				conn = DBConnectionMgrJDBC.getConnection();
			else if (CommonMap.getValue("/prj/conf/useDB").equals("JNDI"))
				conn = DBConnectionMgrJNDI.getConnection();
		} catch (SQLException e) {
			e.printStackTrace();
			throw e;
		} catch (NamingException e) {
			e.printStackTrace();
		}
		return conn;
	}
	
	public static Connection getConnection(String name) throws SQLException {
		Connection conn = null;
		try {
			if (CommonMap.getValue("/prj/conf/useDB").equals("JDBC"))
				conn = DBConnectionMgrJDBC.getConnection();
			else if (CommonMap.getValue("/prj/conf/useDB").equals("JNDI"))
				conn = DBConnectionMgrJNDI.getConnection();
		} catch (SQLException e) {
			e.printStackTrace();
			throw e;
		} catch (NamingException e) {
			e.printStackTrace();
		}
		return conn;
	}
	
	public static void close(Connection conn) {
		try {
			conn.close();
		} catch (Exception e) {
		}
	}

	public static void close(PreparedStatement pstmt) {
		try {
			pstmt.close();
		} catch (Exception e) {
		}
	}

	public static void close(ResultSet rs) {
		try {
			rs.close();
		} catch (Exception e) {
		}
	}

	public static void close(Statement stmt) {
		try {
			stmt.close();
		} catch (Exception e) {
		}
	}
}
