package com.lsf.support;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.OutputStream;
import java.io.UnsupportedEncodingException;
import java.security.Principal;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.List;
import java.util.Locale;
import java.util.Map;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletInputStream;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.FileUploadException;
import org.apache.commons.fileupload.disk.DiskFileItem;
import org.apache.commons.fileupload.disk.DiskFileItemFactory;
import org.apache.commons.fileupload.servlet.ServletFileUpload;
import org.apache.commons.io.IOUtils;

public class HttpMultipartRequest implements HttpServletRequest {
	HttpServletRequest req;
	public List fileItemList;
	public List attachFileItemList;

	public HttpMultipartRequest(HttpServletRequest req) throws FileUploadException {
		this.req = req;

		if (ServletFileUpload.isMultipartContent(req)) {
			final String uploadDir = com.lsf.util.CommonMap.getValue("/prj/system/upload_temp");
			File uploadFile = new File(uploadDir);
			if (!uploadFile.exists())
				uploadFile.mkdirs();

			DiskFileItemFactory fileItemFactory = new DiskFileItemFactory(
					DiskFileItemFactory.DEFAULT_SIZE_THRESHOLD, uploadFile);
			ServletFileUpload upload = new ServletFileUpload(fileItemFactory);
			fileItemList = upload.parseRequest(req);
		}

		if (fileItemList != null) {
			for (int i=0; i<fileItemList.size(); i++) {
				FileItem item = (DiskFileItem) fileItemList.get(i);
				if (item.getContentType() != null) {
					if (attachFileItemList == null) attachFileItemList = new ArrayList();
					attachFileItemList.add(item);
				}

			}
		}
	}

	/**
	 * ÷  Ѵ.
	 * @return
	 */
	public int AttachFileCount() {
		if (attachFileItemList == null) return 0;
		return attachFileItemList.size();
	}

	public int copyAttachFile(int index, OutputStream os) throws Exception {
		DiskFileItem item = (DiskFileItem)attachFileItemList.get(index);
		return IOUtils.copy(item.getInputStream(), os);
	}

	public String getAuthType() {
		return req.getAuthType();
	}

	public String getContextPath() {
		return req.getContextPath();
	}

	public Cookie[] getCookies() {
		return req.getCookies();
	}

	public long getDateHeader(String str) {
		return req.getDateHeader(str);
	}

	public String getHeader(String str) {
		return req.getHeader(str);
	}

	public Enumeration getHeaderNames() {
		return req.getHeaderNames();
	}

	public Enumeration getHeaders(String str) {
		return req.getHeaders(str);
	}

	public int getIntHeader(String str) {
		return req.getIntHeader(str);
	}

	public String getMethod() {
		return req.getMethod();
	}

	public String getPathInfo() {
		return req.getPathInfo();
	}

	public String getPathTranslated() {
		return req.getPathTranslated();
	}

	public String getQueryString() {
		return req.getQueryString();
	}

	public String getRemoteUser() {
		return req.getRemoteUser();
	}

	public String getRequestURI() {
		return req.getRequestURI();
	}

	public StringBuffer getRequestURL() {
		return req.getRequestURL();
	}

	public String getRequestedSessionId() {
		return req.getRequestedSessionId();
	}

	public String getServletPath() {
		return req.getServletPath();
	}

	public HttpSession getSession() {
		return req.getSession();
	}

	public HttpSession getSession(boolean b) {
		return req.getSession(b);
	}

	public Principal getUserPrincipal() {
		return req.getUserPrincipal();
	}

	public boolean isRequestedSessionIdFromCookie() {
		return req.isRequestedSessionIdFromCookie();
	}

	public boolean isRequestedSessionIdFromURL() {
		return req.isRequestedSessionIdFromURL();
	}

	public boolean isRequestedSessionIdFromUrl() {
		return req.isRequestedSessionIdFromUrl();
	}

	public boolean isRequestedSessionIdValid() {
		return req.isRequestedSessionIdValid();
	}

	public boolean isUserInRole(String str) {
		return req.isUserInRole(str);
	}

	public Object getAttribute(String str) {
		return req.getAttribute(str);
	}

	public Enumeration getAttributeNames() {
		return req.getAttributeNames();
	}

	public String getCharacterEncoding() {
		return req.getCharacterEncoding();
	}

	public int getContentLength() {
		return req.getContentLength();
	}

	public String getContentType() {
		return req.getContentType();
	}

	public ServletInputStream getInputStream() throws IOException {
		return req.getInputStream();
	}

	public String getLocalAddr() {
		return req.getLocalAddr();
	}

	public String getLocalName() {
		return req.getLocalName();
	}

	public int getLocalPort() {
		return req.getLocalPort();
	}

	public Locale getLocale() {
		return req.getLocale();
	}

	public Enumeration getLocales() {
		return req.getLocales();
	}

	public String getParameter(String str) {
		return req.getParameter(str);
	}

	public Map getParameterMap() {
		return req.getParameterMap();
	}

	public Enumeration getParameterNames() {
		return req.getParameterNames();
	}

	public String[] getParameterValues(String str) {
		return req.getParameterValues(str);
	}

	public String getProtocol() {
		return req.getProtocol();
	}

	public BufferedReader getReader() throws IOException {
		return req.getReader();
	}

	public String getRealPath(String arg0) {
		return req.getRealPath(arg0);
	}

	public String getRemoteAddr() {
		return req.getRemoteAddr();
	}

	public String getRemoteHost() {
		return req.getRemoteHost();
	}

	public int getRemotePort() {
		return req.getRemotePort();
	}

	public RequestDispatcher getRequestDispatcher(String str) {
		return req.getRequestDispatcher(str);
	}

	public String getScheme() {
		return req.getScheme();
	}

	public String getServerName() {
		return req.getServerName();
	}

	public int getServerPort() {
		return req.getServerPort();
	}

	public boolean isSecure() {
		return req.isSecure();
	}

	public void removeAttribute(String str) {
		req.removeAttribute(str);
	}

	public void setAttribute(String str, Object obj) {
		req.setAttribute(str,obj);
	}

	public void setCharacterEncoding(String str) throws UnsupportedEncodingException {
		req.setCharacterEncoding(str);
	}
}
