package com.lsf.util;

import java.io.File;
import java.util.HashMap;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

public class CommonMap extends HashMap {
	private static CommonMap me = null;

	public String baseRepository;

	private CommonMap(String dir) {
		baseRepository = dir;
	}

	public synchronized static CommonMap getInstance() {
		try {
			InitialContext ctx = new InitialContext();
			String envValue = (java.lang.String) ctx.lookup("java:comp/env/common.xml");
			return getInstance(envValue);
		} catch (NamingException e) {
			e.printStackTrace();
		}
		return null;
	}

	private synchronized static CommonMap getInstance(String dir) {
		if (me == null)
			me = new CommonMap(dir);
		return me;
	}

	public static String getValue(String id) {
		CommonMap map = getInstance();
		if (map.baseRepository == null) return null;
		String cls = null;
		cls = map.readFromHash(id);
		if (cls != null) {
			return cls;
		}

		cls = map.readFromFile(id);


		return cls;
	}

	private String readFromFile(String id) {
		String result = null;

		Node n;

		try {
			n = findNode(id);
			if (n != null)
				result = n.getFirstChild().getNodeValue();
		} catch (Exception e) {
			e.printStackTrace();
		}

		if (result != null) {
			if (result.indexOf("%BASE_DIR")>=0) {
				result = result.replaceAll("%BASE_DIR%", CommonMap.getValue("/prj/conf/baseDir"));
			}
			this.put(id, result);
		}

		return result;
	}

	protected Node findNode(String id) throws Exception {
		String[] key = id.split("/");

		File f = new File(baseRepository);
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		factory.setIgnoringElementContentWhitespace(true);
		DocumentBuilder builder = factory.newDocumentBuilder();
		Document document = builder.parse(f);
		Node node = document;
		for (int i = 0; i < key.length; i++)
			if (!key[i].equals("")) {
				node = findNode(node, key[i]);
				if (node == null) return null;
			}

		if (node.equals(document))
			return null;
		else
			return node;
	}

	private Node findNode(Node parent, String id) {
		Node result = null;
		for (Node n = parent.getFirstChild(); n != null; n = n.getNextSibling()) {
			if (n.getNodeType() != Node.ELEMENT_NODE)
				continue;

			if (n.getNodeName().equals(id))
				result = n;
		}
		return result;
	}

	private String readFromHash(String id) {
		return (String) this.get(id);
	}

	public void resourceRefresh() {
		this.clear();
	}
}
