/*
 * Created on 2004. 12. 7
 *
 */
package com.lsf.util;

import java.io.UnsupportedEncodingException;
import java.text.DecimalFormat;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.lang.StringEscapeUtils;
import org.apache.commons.lang.StringUtils;
import org.apache.commons.lang.math.NumberUtils;

/**
 * @author õȣ
 * 
 */
public class CommonUtil {
	public static final String CONTEXT_PATH = "";

	public static String basehref(HttpServletRequest request) {
		return "http://" + request.getServerName() + ":"
				+ request.getServerPort() + request.getContextPath();
	}

	public static String asc2ksc(String str)
			throws UnsupportedEncodingException {
		str = StringUtils.trimToEmpty(str);
		byte[] x = str.getBytes("iso-8859-1");
		return new String(x, "euc-kr");
	}

	public static String ksc2asc(String str)
			throws UnsupportedEncodingException {
		str = StringUtils.trimToEmpty(str);
		byte[] x = str.getBytes("euc-kr");
		return new String(x, "iso-8859-1");
	}

	public static String escapeSql(String str) {
		str = StringUtils.trimToEmpty(str);
		return StringEscapeUtils.escapeSql(str);
	}

	public static String unescapeSql(String str) {
		str = StringUtils.trimToEmpty(str);
		return str;
	}

	public static String cutString(String val, int len, String tail)
			throws UnsupportedEncodingException {
		if (val == null || val.equals(""))
			return "";
		// if( val.length() <= len ) return val;
		String retStr = val;
		try {
			byte[] temp = val.getBytes();
			if (temp.length <= len)
				return val;
			byte[] ret = new byte[len + 1];
			for (int i = 0; i < len; i++) {
				/** ѱ  */
				if (temp[i] < 0) {
					ret[i] = temp[i];
					// ret[i+1] = temp[i+1];
					i++;
				}
				ret[i] = temp[i];
			}
			retStr = new String(ret, "euc-kr") + tail;
		} catch (Exception e) {
			retStr = "";
		}
		return retStr;
	}

	public static String nvl(String str) {
		return StringUtils.trimToEmpty(str);
	}

	public static int intValue(String str) {
		return NumberUtils.stringToInt(str);
	}

	public static String escapeHtml(String str) {
		return StringEscapeUtils.escapeHtml(str);
	}

	public static String unescapeHtml(String str) {
		return StringEscapeUtils.unescapeHtml(str);
	}

	public static String formatSize(int size) {
		String result = "";
		DecimalFormat df = new DecimalFormat("##0.#");

		double f = 0;
		if (size / (1024 * 1024 * 1024) > 1) {
			f = (double) size / (1024 * 1024 * 1024);
			result = df.format(f) + "G";
		} else if (size / (1024 * 1024) > 1) {
			f = (double) size / (1024 * 1024);
			result = df.format(f) + "M";
		} else if (size / (1024) > 1) {
			f = (double) size / 1024;
			result = df.format(f) + "K";
		} else {
			f = (double) size;
			result = df.format(f) + "";
		}

		return result + "B";
	}

	/**
	 * size ̸ŭ ڿ .
	 * @param size
	 * @return
	 */
	public static String makeRandomString(int size) {
		String[] arr = "0,1,2,3,4,5,6,7,8,9,A,B,C,D,E,F,G,H,I,J,K,L,M,N,O,P,Q,R,S,T,U,V,W,X,Y,Z"
				.split(",");
		
		String tmp = "";
		for (int i = 0; i < size; i++) {
			String s = arr[(int) Math.floor(Math.random() * arr.length)];
			if (i==0) {
				try {
					Integer.parseInt(s);
				} catch (Exception e) {
					tmp = s;
					continue;
				}
				i--;
			}
			else
				tmp += s;
		}

		return tmp;
	}
}
