package com.lsf.util;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

public class NavigationMap extends HashMap {
	private static NavigationMap me = null;

	private boolean dynamicLoad = false;

	private String baseRepository;

	private NavigationMap() {
		baseRepository = CommonMap.getValue("/prj/conf/navigationFile");
		dynamicLoad = Boolean.valueOf(CommonMap.getValue("/prj/conf/navigationAutoReload")).booleanValue();
	}

	public static NavigationMap getInstance() {
		if (me == null)
			me = new NavigationMap();
		return me;
	}

	public static String getClass(String id) {
		NavigationMap map = getInstance();
		String cls = null;
		if (!map.dynamicLoad) {
			cls = map.readFromHash(id);
			if (cls != null)
				return cls;
		}

		try {
			cls = map.readFromFile(id);
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return cls;
	}

	private String readFromFile(String id) throws ParserConfigurationException,
			SAXException, IOException {
		String result = null;

		String dir = baseRepository;

		String key = id;

		File f = new File(dir);
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		factory.setIgnoringElementContentWhitespace(true);
		DocumentBuilder builder = factory.newDocumentBuilder();
		Document document = builder.parse(f);
		Node root = document.getFirstChild();
		if (root.getNodeName().toLowerCase().equals("navigation")) {
			for (Node n = root.getFirstChild(); n != null; n = n
					.getNextSibling()) {
				if (n.getNodeType() != Node.ELEMENT_NODE)
					continue;

				NamedNodeMap map = n.getAttributes();

				if (n.getNodeName().toLowerCase().equals("channel"))
					if (key.equals(map.getNamedItem("id").getNodeValue())) {
						for (Node childNode = n.getFirstChild(); childNode != null; childNode = childNode
						.getNextSibling()) {
							if (childNode.getNodeName().equals("class"))
								result = childNode.getFirstChild().getNodeValue();
						}
					}
			}
		}

		if (result != null) {
			this.put(id, result);
		}

		return result;
	}

	private String readFromHash(String id) {
		return (String) this.get(id);
	}

	public void resourceRefresh() {
		this.clear();
	}
}
