package com.lsf.util;

import java.io.File;
import java.io.IOException;
import java.util.HashMap;

import javax.naming.InitialContext;
import javax.naming.NamingException;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.xml.sax.SAXException;

public class PageMap extends HashMap {
	private static PageMap me = null;

	private boolean dynamicLoad = false;

	private String baseRepository;

	private PageMap() {
		baseRepository = CommonMap.getValue("/prj/conf/navigationFile");
		dynamicLoad = Boolean.valueOf(CommonMap.getValue("/prj/conf/navigationAutoReload")).booleanValue();
	}

	public static PageMap getInstance() {
		if (me == null)
			me = new PageMap();
		return me;
	}

	public static String getPage(String url, String pageId) {

		String[] tempUrl = url.split("/");
		String classId = tempUrl[tempUrl.length-1];

		String extension = "";
		try {
			InitialContext ctx = new InitialContext();
			extension = (java.lang.String) ctx.lookup("java:comp/env/extension");
		} catch (NamingException e) {
			e.printStackTrace();
		}

		classId = classId.replaceAll("."+extension, "");

		PageMap map = getInstance();
		String cls = null;
		if (!map.dynamicLoad) {
			cls = map.readFromHash(classId, pageId);
			if (cls != null)
				return cls;
		}

		try {
			cls = map.readFromFile(classId, pageId);
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return cls;
	}

	private String readFromFile(String classId, String pageId) throws ParserConfigurationException,
			SAXException, IOException {
		String dir = baseRepository;

		String key = classId;

		File f = new File(dir);
		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
		factory.setIgnoringElementContentWhitespace(true);
		DocumentBuilder builder = factory.newDocumentBuilder();
		Document document = builder.parse(f);
		Node root = document.getFirstChild();
		HashMap pageMap = null;

		if (root.getNodeName().toLowerCase().equals("navigation")) {
			for (Node n = root.getFirstChild(); n != null; n = n
					.getNextSibling()) {
				if (n.getNodeType() != Node.ELEMENT_NODE)
					continue;

				NamedNodeMap map = n.getAttributes();

				if (n.getNodeName().toLowerCase().equals("channel"))
					if (key.equals(map.getNamedItem("id").getNodeValue())) {
						pageMap = new HashMap();
						for (Node childNode = n.getFirstChild(); childNode != null; childNode = childNode
						.getNextSibling()) {
							NamedNodeMap childMap = childNode.getAttributes();
							if (childNode.getNodeName().equals("page"))
								try {
									pageMap.put(childMap.getNamedItem("id").getNodeValue(), childNode.getFirstChild().getNodeValue());
								} catch (Exception e) {
								}
						}
					}
			}
		}

		if (pageMap != null) {
			this.put(classId, pageMap);
		}

		return (String) pageMap.get(pageId);
	}

	private String readFromHash(String classId, String pageId) {
		//return (String) this.get(id);
		return (String)((HashMap) this.get(classId)).get(pageId);
	}

	public void resourceRefresh() {
		this.clear();
	}
}
